<?php 

class DS_WooStatistics {
    
    private static $initiated = false;
	public static function init() {
		if ( ! self::$initiated ) {
			self::init_hooks();
		}
	}

    private static function init_hooks() {
		self::$initiated = true;

        // Add initial hooks here.
        add_action('admin_menu', function() {
            add_menu_page('Woo Statistics', 'Woo Stats by DS', 'manage_options', 'ds_woostatistics', array('DS_WooStatistics', 'plugin_dashboard'));
        });

        
    }

    public static function plugin_activation() {

        // Check if Woocommerce is installed 
        $installed_plugins = get_plugins();

        if(array_key_exists( 'woocommerce-subscriptions/woocommerce-subscriptions.php', $installed_plugins ) || in_array( 'woocommerce-subscriptions/woocommerce-subscriptions.php', $installed_plugins, true )) {
           add_action('admin_notices', array('DS_WooStatistics', 'successful_activation') );

        } else {
            @trigger_error(__('Please install and activate Woocommerce subscriptions before activating subscriptions Statistics extension.', 'ap'), E_USER_ERROR);
        }
    }

    public static function successful_activation() {
        return 'subscriptions Statistics is successfully activated. View Stats.';
    }

    /**
    * Plugin Dashboard
    */
    public static function plugin_dashboard() {
        
        echo '<h3> Woocommerce statistics extension by Digital Setups for Simplicity Lovers.';
        $active_tab = isset( $_GET[ 'tab' ] ) ? $_GET[ 'tab' ] : 'general';

        ?>
        <h2 class="nav-tab-wrapper">
		        <a href="?page=ds_woostatistics&tab=general" class="nav-tab <?php echo $active_tab == 'general' ? 'nav-tab-active' : ''; ?>">General</a>
		        <a href="?page=ds_woostatistics&tab=subscriptions" class="nav-tab <?php echo $active_tab == 'subscriptions' ? 'nav-tab-active' : ''; ?>">Subscriptions</a>
	    </h2>

        <script src="<?php echo plugin_dir_url( __FILE__ ) . 'plotly.js'; ?>"></script>

        <?php if($active_tab == 'subscriptions') { global $wpdb; ?>

        <section style="width:95%;background:#e3e3e3;border-radius:12px;padding:10px;margin:20px 10px;">
            <div style="display:flex;flex-direction:row;flex: 1 1; justify-content:space-between;align-items:center;margin-bottom:20px;">
                <div>
                    Statistics
                </div>    
                <div>
                        <form style="display:flex;" action="<?php echo "//".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']; ?>" method="POST">
                            <select name="subscription_product">
                                <?php
                                    $subscription_products =  $wpdb->get_results ("
                                        SELECT * FROM {$wpdb->prefix}posts AS subscription_products
                                            INNER JOIN {$wpdb->prefix}term_relationships AS term_relationships ON subscription_products.ID = term_relationships.object_id
                                            INNER JOIN {$wpdb->prefix}term_taxonomy AS term_taxonomy ON term_relationships.term_taxonomy_id = term_taxonomy.term_taxonomy_id
                                            INNER JOIN {$wpdb->prefix}terms AS terms ON term_taxonomy.term_id = terms.term_id
                                            WHERE
                                                term_taxonomy.taxonomy = 'product_type'
                                            AND terms.slug = ('subscription' OR 'subscription_variation')
                                            AND subscription_products.post_type = 'product'
                                            AND subscription_products.post_status = 'publish';
                                    ");
                        
                        

                                    if(count($subscription_products) > 0) {
                                        foreach($subscription_products as $sp) {
                                            echo '<option value="' . $sp->ID . '">' . $sp->post_title . '</option>'; 
                                        }
                                    } else {
                                         echo '<option disabled>No Subscription Products</option>'; 
                                    }
                                ?>   
                             </select>
                             <input type="submit" value="View Stats"/>
                            </form>
                        </div>
                     </div>

                    <?php 
                        if(count($subscription_products) > 0) { 
                            $first_product_id = $subscription_products[0]->ID;

                            if(isset($_POST['subscription_product'])) {
                                $first_product_id = $_POST['subscription_product'];
                            }

                            $active_subscriptions = $wpdb->get_var("
                                SELECT COUNT(p.ID)
                                FROM {$wpdb->prefix}posts as p
                                LEFT JOIN {$wpdb->prefix}posts AS p2 ON p.post_parent = p2.ID
                                LEFT JOIN {$wpdb->prefix}postmeta AS pm ON p2.ID = pm.post_id
                                LEFT JOIN {$wpdb->prefix}woocommerce_order_items AS woi ON pm.post_id = woi.order_id
                                LEFT JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS woim ON woi.order_item_id = woim.order_item_id
                                WHERE p.post_type LIKE 'shop_subscription' 
                                AND p2.post_type LIKE 'shop_order' AND woi.order_item_type LIKE 'line_item'
                                AND woim.meta_key = '_product_id'
                                AND woim.meta_value = '$first_product_id'
                                AND p.post_status LIKE ('wc-active' OR 'wc-switched')
                            ");

                            $net_revenue = (float) $wpdb->get_var( $wpdb->prepare("
                                SELECT SUM(o.product_net_revenue) 
                                FROM {$wpdb->prefix}wc_order_product_lookup o 
                                INNER JOIN {$wpdb->prefix}posts p
                                    ON o.order_id = p.ID
                                WHERE p.status = 'wc-completed'
                                    AND o.product_id = %d
                            ",$first_product_id ) );

                            ?>

                       
                    <div style="display:flex;flex-direction:row;justify-content:space-evenly;align-items:center;margin: 5px 0px;">
                        
                        <div id="total_subs" style="padding: 2px 5px;height:150px;display: flex;">
                            <div style="
    background: #fff; margin: 5px; padding: 10px; border-radius: 12px; display: flex; flex-direction: column; align-items: center; flex: 1; text-align: center;justify-content: center;">
                                <h3 style="font-size:50px;margin:10px;"><?php echo $active_subscriptions; ?></h3>
                                <p>Total Active Subscriptions</p>
                            </div>
                            <div style="
    background: #fff; margin: 5px; padding: 10px; border-radius: 12px; display: flex; flex-direction: column; align-items: center; flex: 1; text-align: center;justify-content: center;">
                                <h3 style="font-size:50px;margin:10px;"><?php echo $net_revenue; ?></h3>
                                <p>Net Revenue</p>
                            </div>
                        </div>

                        <?php 
                            $on_hold_subscriptions = $wpdb->get_var("
                                SELECT COUNT(p.ID)
                                FROM {$wpdb->prefix}posts as p
                                LEFT JOIN {$wpdb->prefix}posts AS p2 ON p.post_parent = p2.ID
                                LEFT JOIN {$wpdb->prefix}postmeta AS pm ON p2.ID = pm.post_id
                                LEFT JOIN {$wpdb->prefix}woocommerce_order_items AS woi ON pm.post_id = woi.order_id
                                LEFT JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS woim ON woi.order_item_id = woim.order_item_id
                                WHERE p.post_type LIKE 'shop_subscription' 
                                AND p2.post_type LIKE 'shop_order' AND woi.order_item_type LIKE 'line_item'
                               
                                AND woim.meta_key = '_product_id'
                                AND woim.meta_value = '$first_product_id'
                                AND p.post_status LIKE 'wc-on-hold'
                            ");
                            
                            $cancelled_subscriptions = $wpdb->get_var("
                                SELECT COUNT(p.ID)
                                FROM {$wpdb->prefix}posts as p
                                LEFT JOIN {$wpdb->prefix}posts AS p2 ON p.post_parent = p2.ID
                                LEFT JOIN {$wpdb->prefix}postmeta AS pm ON p2.ID = pm.post_id
                                LEFT JOIN {$wpdb->prefix}woocommerce_order_items AS woi ON pm.post_id = woi.order_id
                                LEFT JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS woim ON woi.order_item_id = woim.order_item_id
                                WHERE p.post_type LIKE 'shop_subscription' 
                                AND p2.post_type LIKE 'shop_order' AND woi.order_item_type LIKE 'line_item'
                                AND pm.meta_key LIKE '_customer_user'
                                AND woim.meta_key = '_product_id'
                                AND woim.meta_value = '$first_product_id'
                                AND p.post_status LIKE ('wc-cancelled' OR 'wc-pending-cancel')
                            ");

                            $expired_subscriptions = $wpdb->get_var("
                                SELECT COUNT(p.ID)
                                FROM {$wpdb->prefix}posts as p
                                LEFT JOIN {$wpdb->prefix}posts AS p2 ON p.post_parent = p2.ID
                                LEFT JOIN {$wpdb->prefix}postmeta AS pm ON p2.ID = pm.post_id
                                LEFT JOIN {$wpdb->prefix}woocommerce_order_items AS woi ON pm.post_id = woi.order_id
                                LEFT JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS woim ON woi.order_item_id = woim.order_item_id
                                WHERE p.post_type LIKE 'shop_subscription' 
                                AND p2.post_type LIKE 'shop_order' AND woi.order_item_type LIKE 'line_item'
                            
                                AND woim.meta_key = '_product_id'
                                AND woim.meta_value = '$first_product_id'
                                AND p.post_status LIKE 'wc-expired'
                            ");

                            $time_now = get_the_date("Y-m-d H:i:s");

                            $in_trial_subscriptions = $wpdb->get_var("
                                SELECT COUNT(p.ID)
                                FROM {$wpdb->prefix}posts as p
                                LEFT JOIN {$wpdb->prefix}posts AS p2 ON p.post_parent = p2.ID
                                LEFT JOIN {$wpdb->prefix}postmeta AS pm ON p2.ID = pm.post_id
                                LEFT JOIN {$wpdb->prefix}woocommerce_order_items AS woi ON pm.post_id = woi.order_id
                                LEFT JOIN {$wpdb->prefix}woocommerce_order_itemmeta AS woim ON woi.order_item_id = woim.order_item_id
                                WHERE p.post_type LIKE 'shop_subscription' 
                                AND p2.post_type LIKE 'shop_order' AND woi.order_item_type LIKE 'line_item'
                                AND pm.meta_key = '_schedule_trial_end'
                                AND pm.meta_value < '$time_now'
                                AND pm.meta_key = '_schedule_start'
                                AND pm.meta_value > '$time_now'
                                AND woim.meta_key = '_product_id'
                                AND woim.meta_value = '$first_product_id'
                                AND p.post_status LIKE ('wc-active' OR 'wc-switched')
                            ");

                        ?>
                        <!-- Chart-->
                        <div id="stats_by_status_wrap" style="padding: 2px 5px;">
                            <canvas id="statsByStatusChart" height="250"></canvas>
                                <script>
                                const ctx = document.getElementById('statsByStatusChart').getContext('2d');
                                const myChart = new Chart(ctx, {
                                    type: 'bar',
                                    options: {
                                        indexAxis: 'y',
                                        plugins: {
                                          legend: {
                                            position: 'right',
                                          },
                                          title: {
                                            display: true,
                                            text: 'Chart.js Horizontal Bar Chart'
                                          }
                                        }
                                    },
                                    data: {
                                        labels: ['In Trial', 'On-Hold', 'Cancelled', 'Active/Switched'],
                                        
                                        datasets: [{
                                            label: '# of Votes',
                                            data: [ <?php echo $in_trial_subscriptions; ?>, 
                                                    <?php echo $on_hold_subscriptions; ?>,
                                                    <?php echo $cancelled_subscriptions; ?>,
                                                    <?php echo $active_subscriptions; ?>
                                                  ],
                                            backgroundColor: [
                                                'rgba(54, 162, 235, 0.2)',
                                                'rgba(255, 206, 86, 0.2)',
                                                'rgba(255, 99, 132, 0.2)',
                                                'rgba(75, 192, 192, 0.2)'
                                            ],
                                            borderColor: [
                                                
                                                'rgba(54, 162, 235, 1)',
                                                'rgba(255, 206, 86, 1)',
                                                'rgba(255, 99, 132, 1)',
                                                'rgba(75, 192, 192, 1)'

                                            ],
                                            borderWidth: 1
                                        }]
                                    },
                                    options: {
                                        scales: {
                                            y: {
                                                beginAtZero: true
                                            }
                                        }
                                    }
                                });
                                </script>
                        </div>
                    </div>

                <?php     
                } else {
                    echo 'There are no subscription products available or published so far.';
                }

             ?>
            
        </section>

        <?php } ?>



        <?php
    }
}

?>